#ifndef WINSTADESK_H
#define WINSTADESK_H

#pragma once

typedef struct _WorkItemContext
{
	UCHAR* pSysProcessBuffer;
	PKEVENT pExitEvent;
	NTSTATUS stat;
} WorkItemContext;

extern "C"
{
	IO_WORKITEM_ROUTINE EnumSessionsAndPrimaryWinstas;
	NTSTATUS GetDesktopHeapInfo(HANDLE hWinSta, PDEVICE_OBJECT pDevObj);
	NTSTATUS ValidateHWinSta(HANDLE hWinSta, struct tagWINDOWSTATION** ppWinSta);
	NTSTATUS GetObjectName(PVOID pObject, PUNICODE_STRING pusName);
	NTSTATUS CreateDesktopEntry(struct tagDESKTOP* pDesk);
	NTSTATUS EnumDesktops(struct tagDESKTOP* pDesk);
	NTSTATUS EnumWindowStations(struct tagWINDOWSTATION* pWinSta);
	NTSTATUS ValidateObject(PVOID pObject, struct _OBJECT_TYPE* pObjectType);
	struct _HEAP* GetPHeapFromPDesktop(struct tagDESKTOP* pDesk);
	NTSTATUS TryEnumAllWindowStations(PDEVICE_OBJECT pDevObj);
	NTSTATUS GetPrimaryWinsta(PUNICODE_STRING pusDirectory, PVOID* ppWinstaObject);
	NTSTATUS GetSessionPrimaryWinsta(ULONG dwSession, PVOID* ppWinsta);
}

#ifdef ALLOC_PRAGMA
#pragma alloc_text(PAGE, EnumSessionsAndPrimaryWinstas)
#pragma alloc_text(PAGE, GetDesktopHeapInfo, ValidateHWinSta)
#pragma alloc_text(PAGE, EnumDesktops, CreateDesktopEntry)
#pragma alloc_text(PAGE, EnumWindowStations, GetPHeapFromPDesktop)
#pragma alloc_text(PAGE, ValidateObject, GetObjectName)
#pragma alloc_text(PAGE, TryEnumAllWindowStations)
#pragma alloc_text(PAGE, GetSessionPrimaryWinsta, GetPrimaryWinsta)
#endif

#endif
